-- Draw Piston w/ Piston Rings and Connecting Rod 
-- Written by Tushar Suradkar
-- 15-Jun-2000
-- www.geocities.com/CadGuruCool


utility MyUtil "Piston"
(
  local pist
  local pring
  local prod
--  local pcap
  
 rollout bout "Pison"
 (
   button aboutPC "About" width:45 height:20
   on aboutPC pressed do
    (
    messagebox "Piston with Piston Rings\n and Connecting Rod \n version 1.0 \n\n Writtenby Tushar Suradkar\nwww.geocities.com/CadGuruCool" title:"About Piston" beep:true
	)
 )
  
  rollout creator "Piston"
  (
  
  Group "Piston"
   (
   spinner outrad "Outer Radius" range:[100,500,200] type:#integer enabled:false
   spinner inrad "Inner Radius" range:[90,480,180] type:#integer enabled:false
   spinner pistht "Piston Length" range:[400,1500,600] type:#integer enabled:false
   spinner pistsides "Body Curvature" range:[30,50,31] type:#integer enabled:false
   spinner pistcapsegs "Piston Head Curv." range:[3,9,6] type:#integer enabled:false
   spinner pisthtsegs "Height Refine" range:[20,60,40] type:#integer enabled:false
   colorpicker pistcol "Piston Color :" color:[25,125,125] align:#center enabled:false
   checkbox chkmappist "Generate Mapping Coords." checked:false enabled:false
   )

  Group "Piston Rings"
   (
   spinner outring "Outer Radius" range:[100,500,200] type:#integer enabled:false
   spinner inring "Inner Radius" range:[90,480,180] type:#integer enabled:false
   spinner ringht "Ring Thickness" range:[10,50,20] type:#integer enabled:false
   spinner ringsides "Ring Curvature" range:[30,50,31] type:#integer enabled:false
   spinner ringcapsegs "Rim Refine" range:[3,9,6] type:#integer enabled:false
   spinner ringhtsegs "Height Refine" range:[20,60,40] type:#integer enabled:false
   checkbox chkmapring "Generate Mapping Coords." checked:false enabled:false
   )

  Group "Connecting Rod"
   (
   spinner rodrad "Radius" range:[10,50,20] type:#integer enabled:false
   spinner rodht  "Rod Length" range:[800,3500,1200] type:#integer enabled:false
   spinner rodhtsegs "Length Refine" range:[20,60,40] type:#integer enabled:false
   spinner rodcapsegs "End Refine" range:[3,9,6] type:#integer enabled:false
   spinner rodsides "Curvature" range:[30,60,31] type:#integer enabled:false
   colorpicker rodcol "Rod Color :" color:[60,125,55] align:#center enabled:false
   checkbox chkmaprod "Generate Mapping Coords." checked:false enabled:false

   )

   checkbox chkrender "Render upon completion" checked:true
--   label:blank1
   button drawpist "Draw All"

  Group "Help"
   (
   label labme "Written by Tushar Suradkar"
   label labsp "www.geocities.com/CadGuruCool"
   button helpPC "Help" width:45 height:20
   )  -- group about

   on helpPC pressed do
    (
    messagebox "Piston with Piston Rings\nand Connecting Rod\nversion 1.0\n\nWritten by : Tushar Suradkar\nwww.geocities.com/CadGuruCool" title:"About Piston" beep:true
	)
	  
   on chkrender changed state do 
   (
    if state == on then 
    qrenderpist = true else qrenderpist = false
   )
	  
  on drawpist pressed do
  (
   outrad.enabled=true
   inrad.enabled=true
   pistht.enabled=true
   pistsides.enabled=true
   pistcapsegs.enabled=true
   pisthtsegs.enabled=true
   pistcol.enabled=true
   chkmappist.enabled=true
   
   outring.enabled=true
   inring.enabled=true
   ringht.enabled=true
   ringsides.enabled=true
   ringcapsegs.enabled=true
   ringhtsegs.enabled=true
   chkmapring.enabled=true
   
   rodrad.enabled=true
   rodht.enabled=true
   rodhtsegs.enabled=true
   rodcapsegs.enabled=true
   rodsides.enabled=true
   rodcol.enabled=true
   chkmaprod.enabled=true

  pist=tube()
  pist.radius1=outrad.value
  pist.radius2=inrad.value
  pist.height=pistht.value
  pist.sides=pistsides.value
  pist.capsegs=pistcapsegs.value
  pist.heightsegs=pisthtsegs.value
  pist.name="p1"
  pist.position=[0,0,0]
  
  pring=tube()
  pring.radius1=outring.value
  pring.radius2=inring.value
  pring.height=ringht.value
  pring.sides=ringsides.value
  pring.capsegs=ringcapsegs.value
  pring.heightsegs=ringhtsegs.value
  pring.name="r1"
  pring.position=[-pist.radius1*1.5,-pist.radius1*1.5,pist.radius1*0.5]
  for i in 1 to 4 do instance pring pos:[-pist.radius1*1.5,-pist.radius1*1.5,pist.radius1*0.3*i]
  hide pring
  
  prod=cylinder()
  prod.radius=rodrad.value
  prod.height=rodht.value
  prod.sides=rodsides.value
  prod.capsegs=rodcapsegs.value
  prod.heightsegs=rodhtsegs.value
  prod.name="c1"
  prod.position=[0,0,0]
  prod.rotation=quat 7 y_axis
  max tool zoomextents
  messagebox "Proceed to fine tune dimensions by tweaking the Spinner values\n\nTry the \"Interactive Color Changer\"\nand watch realtime color update in the viewports !" title:"Piston Done !" beep:true

  if qrenderpist == true then 
   (
     max quick render 
   )
    else qrenderpist=false
   )
 
   on pistcol changed val do pist.wirecolor = val
   on rodcol changed val do prod.wirecolor = val
 
  on outrad changed value do
  (
  pist.radius1=outrad.value
  ) 

  on inrad changed value do
  (
  pist.radius2=inrad.value
  ) 

  on pistht changed value do
  (
  pist.height=pistht.value
  )
  
  on pistsides changed value do
  (
  pist.sides=pistsides.value
  )
  
  on pistcapsegs changed value do
  (
  pist.capsegs=pistcapsegs.value
  )
  
  on pisthtsegs changed value do
  (
  pist.heightsegs=pisthtsegs.value
  )
  
-- end of  piston spinners

  on outring changed value do
  (
  pring.radius1=outring.value
  ) 

  on inring changed value do
  (
  pring.radius2=inring.value
  ) 

  on ringht changed value do
  (
  pring.height=ringht.value
  )
  
  on ringsides changed value do
  (
  pring.sides=ringsides.value
  )
  
  on ringcapsegs changed value do
  (
  pring.capsegs=ringcapsegs.value
  )
  
  on ringhtegs changed value do
  (
  pring.heightsegs=ringhtsegs.value
  )

  
-- end of ring spinners

  on rodrad changed value do
  (
  prod.radius=rodrad.value
  )

  on rodht changed value do
  (
  prod.height=rodht.value
  )
  
  on rodsides changed value do
  (
  prod.sides=rodsides.value
  )

  on rodcapsegs changed value do
  (
  prod.capsegs=rodcapsegs.value
  )

  on rodhtegs changed value do
  (
  prod.heightsegs=rodhtsegs.value
  )

-- end rod spinner
  
  ) --  rollout create "Wow I'm Floating!"

 on MyUtil open do
 (
  nr=NewRolloutFloater "Piston" 220 410
  addRollout creator nr
  addRollout bout rolledup;true
  messagebox "Piston with PistonRing + Connecting Rod creator\nversion 1.0.0\n\nFreeware By CadGuruCool\nModify,Distribute,Tweak,Sell freely\n\nEnjoy Rocking !" title:"Piston" beep:true

 )

)-- end utility
